﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Xml.Linq;
using System.Drawing;

using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.Misc;
using Styx.WoWInternals.World;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;
using Styx.CommonBot.Frames;
using Styx.CommonBot;


/* Credits to Hazard for all the code from RepCollector */

namespace CollectUnderWater
{
    class CollectUnderWater : HBPlugin
    {
        public static string name { get { return "UnderWater Collector "; } }
        public override string Name { get { return name; } }
        public override string Author { get { return "Superyeti"; } }
        private readonly static Version _version = new Version(1, 0);
        public override Version Version { get { return _version; } }
        public override string ButtonText { get { return "Don't touch me"; } }
        public override bool WantButton { get { return false; } }
        public static LocalPlayer Me { get { return StyxWoW.Me; } }

		public static float richGhostIronDeposit = 209328;
		public static float GhostIronDeposit = 209311;
		public static float TrilliumVein = 209313;
		public static float RichTrilliumVein = 209330;
		public static float FoolsCap = 209355;
		public static float GoldenLotus = 209354;
		
        public override void Pulse()
        {
            Thread.Sleep(1 / 30);
            try
            {
                if (!Me.Combat || !Me.IsDead)
                    objs();
            }
            catch (ThreadAbortException)
            {
            }
        }

        public static void MoveToLocation(WoWPoint loc)
        {
            while (loc.Distance(Me.Location) > 3)
            {
			    Thread.Sleep(500);
				Flightor.MountHelper.MountUp();
                Flightor.MoveTo(loc);
            }
			WoWMovement.MoveStop();
        }

		public static bool isNode (float i)
		{
			return (i == richGhostIronDeposit || i == GhostIronDeposit || i == TrilliumVein || i == RichTrilliumVein || i ==  FoolsCap || i == GoldenLotus);
		}
		
		public static void aff(float id)
		{
			string s;
			if (id == richGhostIronDeposit)
				s = "Rich Ghost iron deposit";
			else if(id == GhostIronDeposit)
				s = "Ghost iron deposit";
			else if (id == TrilliumVein)
				s = "Trillium vein";
			else if (id == RichTrilliumVein)
				s = "Rich Trillium vein";
			else if (id == GoldenLotus)
				s = "Golden lotus";
			else
				s = "Fool's cap";
			Logging.Write("[UnderWater Collector]: Gathered " + s + ".");
		}
		
        static public void objs()
        {
            ObjectManager.Update();
            List<WoWGameObject> objList = ObjectManager.GetObjectsOfType<WoWGameObject>()
                .Where(objs => (objs.Distance2D <= 40 && (isNode(objs.Entry)))).OrderBy(objs => objs.Distance).ToList();
            foreach (WoWGameObject objs in objList)
            {
				if (objs.Z > 0) return;
				/* if (!objs.InLineOfSight) return; */
                if (Me.Combat) return;
				MoveToLocation(objs.Location);
                Flightor.MountHelper.Dismount();
                Thread.Sleep(1000);
                objs.Interact();
                Thread.Sleep(2500);
                aff(objs.Entry);
                Flightor.MountHelper.MountUp();
				return;
            }
        }
    }
}